#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef int64_t ll, i64;
typedef uint64_t ull, u64;
const int N = 1005 * 1005;
const double eps = 1e-8;
int a[1605], x[45];
int main()
{
    int T, n;
    double p;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d%lf", &n, &p);
        for (int i = 1; i <= n; i++)
            cin >> x[i];
        a[0] = 0;
        int co = 1;
        for (int i = 0; i <= n; i++)
            for (int j = i + 1; j <= n; j++)
                a[co++] = x[i] + x[j];
        sort(a, a + co);
        n = (1.0 - p < eps) ? n : (int)(p * pow(2, n));
        cout << a[n - 1] << endl;
    }
    return 0;
}
